import java.awt.Color;

public class Aitken
{
    private int MAX_KP = 20;
    private int anzKontrollPunkte = 0;
    private int KontrollPunkte[][] = new int[MAX_KP][2];
    private int movingPoint = -1;
    private static final int X=0;
    private static final int Y=1;


    private double getValue(int a,int b,double x)
    {
      if (a==b)
        return (double)(KontrollPunkte[a][Y]);
      else
      {
        double tmp1=((KontrollPunkte[b][X]-x)/((double)(KontrollPunkte[b][X]-KontrollPunkte[a][X])))*getValue(a,b-1,x);
        double tmp2=((x-KontrollPunkte[a][X])/((double)(KontrollPunkte[b][X]-KontrollPunkte[a][X])))*getValue(a+1,b,x);
        return tmp1+tmp2;
      } // else
    } // getValue()
    
    public void draw(CG1NewCanvas c)
    {
      drawKontrollPunkte(c);
      drawKurve(c);
    }

    private void drawKontrollPunkte(CG1NewCanvas c)
    {
      for (int i=0; i<anzKontrollPunkte; i++)
      {
        int x = KontrollPunkte[i][X];
        int y = KontrollPunkte[i][Y];
    
        CG1Line line = new CG1Line(x-5, y-5, x+5, y-5, Color.red);
        line.draw(c);
        line = new CG1Line(x-5, y+5, x+5, y+5, Color.red);
        line.draw(c);
        line = new CG1Line(x+5, y-5, x+5, y+5, Color.red);
        line.draw(c);
        line = new CG1Line(x-5, y-5, x-5, y+5, Color.red);
        line.draw(c);
      }
    }

    
    private double computeH(double[] p1,double[] p2,double[] p3)
    {
      if (p3[X]==p1[X])
      {
        System.out.println("fggleges vonal!");
        return (Math.abs(p3[X]-p2[X]));
      }
      else
      {
        if (p3[Y]==p1[Y])
        {
          System.out.println("vzszintes vonal!");
          return (Math.abs(p2[Y]-p1[Y]));
        }
        else
        {
          double m=(p3[Y]-p1[Y])/(p3[X]-p1[X]); System.out.println("         m = "+m);
          double b=p1[Y]-m*p1[X];               System.out.println("         b = "+b);
          double m_other=-m;                    System.out.println("   m_other = "+m_other);
          double b_other=p2[Y]-m_other*p2[X];   System.out.println("   b_other = "+b_other);
          double res_x=(b_other-b)/(2.0*m);     System.out.println("     res_x = "+res_x);
          double res_y=m*res_x+b;               System.out.println("     res_y = "+res_y);
          double dx=p2[X]-res_x;                System.out.println("        dx = "+dx);
          double dy=p2[Y]-res_y;                System.out.println("        dy = "+dy);
          return Math.sqrt(dx*dx+dy*dy);
        } // else
      } // else
    } // computeH()


    private int findMinX()
    {
      int minx=KontrollPunkte[0][X];
      
      for (int i=1; i<anzKontrollPunkte; i++)
      {
        if (KontrollPunkte[i][X]<minx)
          minx=KontrollPunkte[i][X];
      }
      
      return minx;
    } // findMinX()

    private int findMaxX()
    {
      int maxx=KontrollPunkte[0][X];
      
      for (int i=1; i<anzKontrollPunkte; i++)
      {
        if (KontrollPunkte[i][X]>maxx)
          maxx=KontrollPunkte[i][X];
      }
      
      return maxx;
    } // findMaxX()


    private void drawKurve(CG1NewCanvas c)
    {
      System.out.println("drawKurve() begin");
     /*
      * pixelweise, ohne autom. Schrittweitensteuerung
      */
      

      double dX=1.0;
      double currX;
      double startX=(double)findMinX();
      double endX=(double)findMaxX();
      
      for (currX=startX; currX<endX; currX+=dX)
      {
        double pointY=getValue(0,anzKontrollPunkte-1,currX);
        c.setPixel((int)currX,(int)pointY,Color.red);
      } // for


      /* mit autom. Schrittweitensteuerung */
/*      
      double dX=0.5;
      double currX=(double)findMinX();
      double endX=(double)findMaxX();
      double u=1.0;
      double o=4.0*u;
      CG1Line line;
      
      double[] p1=new double[2];
      p1[X]=currX; p1[Y]=getValue(0,anzKontrollPunkte-1,currX);
      currX+=dX;

      double[] p2=new double[2];
      p2[X]=currX; p2[Y]=getValue(0,anzKontrollPunkte-1,currX);
      currX+=dX;

      double[] p3=new double[2];
      p3[X]=currX; p3[Y]=getValue(0,anzKontrollPunkte-1,currX);

      while (currX<endX)
      {
        System.out.println("p1X="+p1[X]+",  p1Y="+p1[Y]);
        System.out.println("p2X="+p2[X]+",  p2Y="+p2[Y]);
        System.out.println("p3X="+p3[X]+",  p3Y="+p3[Y]);
        double h=computeH(p1,p2,p3);
        
        System.out.println("H = "+h);
        
        if (h<u) // h sehr klein
        {
          System.out.println("dt zu klein");
          line = new CG1Line((int)p1[X],(int)p1[Y],(int)p2[X],(int)p2[Y],Color.red);
          line.draw(c);
          dX*=1.5;
          currX+=dX;
          p1=p2;
          p2=p3;
          p3[X]=currX; p3[Y]=getValue(0,anzKontrollPunkte-1,currX);
        }
        else if (h>=u && h<o) // dt ist richtig
        {
          System.out.println("dt OK");
          line = new CG1Line((int)p1[X],(int)p1[Y],(int)p2[X],(int)p2[Y],Color.red);
          line.draw(c);
          currX+=dX;
          p1=p2;
          p2=p3;
          p3[X]=currX; p3[Y]=getValue(0,anzKontrollPunkte-1,currX);
        }
        else // h ist zu gro
        {
          System.out.println("dt zu gro");
          currX-=dX;
          double save=currX; // now it is at p2
          currX-=dX; // zurueck zu p1
          dX/=1.5;
          currX+=dX;
          p3=p2;
          p2[X]=currX; p2[Y]=getValue(0,anzKontrollPunkte-1,currX);
          currX=save; // at the new p3
        } // else
      } // while
*/
    } // drawKurve()


    public void moveKontrollPunkt(int x, int y)
    {
      KontrollPunkte[movingPoint][X] = x;
      KontrollPunkte[movingPoint][Y] = y;
    }

    public void addKontrollPunkt(int x, int y)
    {
      boolean move = false;

      for (int i=0; i<anzKontrollPunkte; i++)
      {
        if ( (Math.abs(x - KontrollPunkte[i][X]) < 5) && (Math.abs(x - KontrollPunkte[i][X]) < 5))
        {
          movingPoint = i;
          move = true;
        }
      } // for
      
      if (!move)
      {
        if (anzKontrollPunkte < MAX_KP)
        {
          KontrollPunkte[anzKontrollPunkte][X] = x;
          KontrollPunkte[anzKontrollPunkte][Y] = y;
          movingPoint = anzKontrollPunkte;
          anzKontrollPunkte++;
        }
      }
    } // addKontrollPunkt()

    public void delKontrollPunkt(int x, int y)
    {
      int delPoint = -1;

      for (int i=0; i<anzKontrollPunkte; i++)
        if ( (Math.abs(x - KontrollPunkte[i][X]) < 5) && (Math.abs(x - KontrollPunkte[i][X]) < 5))
          delPoint = i;

      if (delPoint >= 0)
      {
        for (int i=delPoint+1; i<anzKontrollPunkte; i++)
        {
          KontrollPunkte[i-1][X] = KontrollPunkte[i][X];
          KontrollPunkte[i-1][Y] = KontrollPunkte[i][Y];
        }
        anzKontrollPunkte--;
      }
    } // delKontrollPunkt()
    
} // class Aitken
