import java.awt.Color;

public class CG1Line
{
    int x1, y1, x2, y2;
    Color col;

    public CG1Line(int nx1, int ny1, int nx2, int ny2, Color color)
    {
        x1 = nx1;
        y1 = ny1;
        x2 = nx2;
        y2 = ny2;
        col = color;

    }

    public void draw(CG1NewCanvas canvas)
    {
	int dx      = Math.abs(x1 - x2);
	int dy      = Math.abs(y1 - y2);
	boolean swap = false;
	
	if (dx < dy)
	    {
		int zw = x1;
		x1 = y1;
		y1 = zw;
		
		zw = x2;
		x2 = y2;
		y2 = zw;
		
		zw = dx;
		dx = dy;
		dy = zw;
		
		swap = true;
	    }
	
	int twoDy   = 2* dy;
	int twoDyDx = 2*(dy - dx);
	int p       = twoDy - dx;
	int x,y,end,dir = 1;
		
	if (x1 < x2)
	    {
		x   = x1;
		y   = y1;
		end = x2;
		
		if (y1 > y2)
		    dir = -1;
	    }
	else
	    {
		x   = x2;
		y   = y2;
		end = x1;
		
		if (y1 < y2)
		    dir = -1;
	    }
	
	if (swap)
	    canvas.setPixel(y,x,col);
	else
	    canvas.setPixel(x,y,col);
	
	while (x < end)
	    {
		x ++;
		if (p < 0)
		    p += twoDy;
		else
		    {
			y += dir;
			p += twoDyDx;
		    }
		
		if (swap)
		    canvas.setPixel(y,x,col);
		else
		    canvas.setPixel(x,y,col);
	    }
    }
}   
