import java.awt.*;
import java.awt.image.*;

public class CG1NewCanvas extends Canvas
{
    int[] imgData;
    ColorModel cm;
    Image img;
    MemoryImageSource misource;
    int width, height;

    private Aitken kurve = new Aitken();

    public CG1NewCanvas()
    {
	width = 512;
	height = 512;

        cm = new DirectColorModel(24, 0x00FF0000, 0x0000FF00, 0x000000FF);

	int anz = width*height;
        imgData = new int[anz];

        misource = new MemoryImageSource(width, height, cm, imgData, 0, width);
        misource.setAnimated(true);
        misource.setFullBufferUpdates(true);
        img = createImage(misource);
    }
    
    public void clear()
    {
        for (int i=0; i<width*height; i++)
	    {
		imgData[i]=0;
	    }
    }

    public void setPixel(int x, int y, Color c)
    {
        if ( x > 0 && x < 512 && y > 0 && y < 512 )
	    imgData[y*getSize().height + x] =
    	    (c.getRed() << 16) | (c.getGreen() << 8) | c.getBlue();
    }
    	
    public void paint(Graphics g)
    {
        misource.newPixels(0,0,img.getWidth(null),img.getHeight(null));
    
        g.drawImage(img, 0, 0, null);
    }

    public int getWidth()
    {
	return width;
    }

    public int getHeight()
    {
	return height;
    }

    public boolean mouseDown(Event e, int x, int y)
    {
	clear();
	    kurve.addKontrollPunkt(x, y);

//	  if (e.key == Event.META_MASK)
//   	      kurve.addKontrollPunkt(x, y);
//	  else
//	      kurve.delKontrollPunkt(x, y);

	kurve.draw(this);

	Graphics g = getGraphics();
	paint(g);
	g.dispose();

	return true;
    }

    public boolean mouseDrag(Event e, int x, int y)
    {
	clear();

	kurve.moveKontrollPunkt(x, y);
	kurve.draw(this);

	Graphics g = getGraphics();
	paint(g);
	g.dispose();

	return true;
    }
}
