/* 
	CG1mainFrame.java

	Title:		LU_CG1_WS2000_2001
	Author:		theussl, viola
	Description:	includes skeleton and all assignments for the CG1
	                lab in winter semester 2000/2001
*/

import java.awt.*;
import java.awt.event.*;

public class CG1mainFrame extends Frame
{
    private static final byte EXIT_BUTTON = 20;

    public CG1NewCanvas myCanvas = new CG1NewCanvas();
    Panel workPanel = new Panel();
    Button exitButton = new Button("Exit!");


    private boolean mShown = false;
    public boolean pressed = false;
    public byte buttonNr;

    public CG1mainFrame()
    {
	setBackground(new Color(170,170,170));
	setResizable(false);
    }
    
    public void initComponents() throws Exception
    {
	myCanvas.setSize(new Dimension(512, 512));
	myCanvas.setVisible(true);
	myCanvas.setLocation(new Point(10, 10));
	
	workPanel.setSize(new Dimension(120, 512));
	workPanel.setLocation (new Point(530, 10));
	workPanel.setBackground(Color.lightGray);
	workPanel.setVisible(true);

	exitButton.setSize(new Dimension(80, 20));
	exitButton.setVisible(true);
	exitButton.setLocation(new Point(550, 482));
	
	setSize(new Dimension(661, 561));
	setLayout(null);
	setTitle("LU_CG1_WS2000_2001.CG1mainFrame");
	setLocation(new Point(0, 0));

      	add(myCanvas);
	add(exitButton);
	add(workPanel);


    	exitButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		exitButtonActionPerformed(e);
	    }
	});

	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		thisWindowClosing(e);
	    }
	});
    }
    
    public void addNotify() 
    {
	super.addNotify();
	
	if (mShown)
	    return;
	
	// move components to account for insets
	Insets insets = getInsets();
	Component[] components = getComponents();
	for (int i = 0; i < components.length; i++) {
	    Point location = components[i].getLocation();
	    location.move(location.x, location.y + insets.top);
	    components[i].setLocation(location);
	}
	
	mShown = true;
    }
    
    // Close the window when the close box is clicked
    void thisWindowClosing(WindowEvent e)
    {
	buttonNr = EXIT_BUTTON;
        setVisible(false);
	dispose();
	System.exit(0);
    }
    
    public void exitButtonActionPerformed(ActionEvent e)
    {
	buttonNr = EXIT_BUTTON;
	setVisible(false);
	dispose();
	System.exit(0);
    }
}

